<%@ page contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib uri="http://www.keyoti.com/" prefix="RapidSpellWeb" %>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>
<title>Spell Check</title>


<%
class CUserDictionary extends com.keyoti.rapidSpell.UserDictionary
 {
  java.util.ArrayList wordList;
  boolean valid = true;
  String cookieName = "keyoti_rapidspell_ud";
Cookie[] cookies;
HttpServletResponse response;
  public CUserDictionary(Cookie[] cookies, HttpServletResponse response){
      this.cookies = cookies;
      this.response = response;
  }

  /** Tries to add <code>word</code> to this dictionary
  * @param word String containing the new word
  * @return true if added successfully, false otherwise.
  */
  public boolean addWord(String word){
            Cookie udCookie = getUDCookie();
          if (udCookie == null) {
                udCookie = new Cookie(cookieName, word);
                response.addCookie(udCookie);                               
          } else
          {
                java.util.ArrayList words = new java.util.ArrayList();
                readAll(words);
                words.add(word);
                StringBuffer newValue = new StringBuffer();
                for(int j=0; j<words.size(); j++)
                    newValue.append(words.get(j).toString()+" ");
                udCookie.setValue(newValue.toString().trim());
                response.addCookie(udCookie); 
          }
            return true;
  }
  
  Cookie getUDCookie() {
          if(cookies==null) return null;
          for (int i = 0; i < cookies.length; i++) {
              Cookie c = cookies[i];
              if (c!=null && c.getName().equals(cookieName)) {
                  return c;
              }
          }
          return null;
      }
 
  /** Read the dictionary word list into <code>list</code>
  * @param list the String arraylist that the word list will be read into.
  * @return number of words in list.
  */
  public int readAll(java.util.ArrayList list) {
          int wordCount = 0;
          Cookie udCookie = getUDCookie();
          if (udCookie != null) {
              String[] words = udCookie.getValue().split(" ");
              wordCount = words.length;
                  
              for (int j = 0; j < words.length; j++) {
                  list.add(words[j]);
              }
                  
          }
          return wordCount;
      }
  /** Returns if the dictionary file is valid. */
  public boolean isValid(){
  return valid;
  }

 }

CUserDictionary ud = new CUserDictionary(request.getCookies(), response);
%>

<body>
<center>
<RapidSpellWeb:rapidSpellWeb

     userDictionary="<%=ud%>"
/>

</center>
</body>
</html>